



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python解惑：整数比较</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python解惑：整数比较</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 08:12:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在 Python 中一切都是对象，毫无例外整数也是对象，对象之间比较是否相等可以用==，也可以用is。==和is操作的区别是：</p>
<p>is比较的是两个对象的id值是否相等，也就是比较俩对象是否为同一个实例对象，是否指向同一个内存地址。 ==比较的是两个对象的内容是否相等，默认会调用对象的__eq__()方法。</p>
<p>清楚is和==的区别之后，对此也许你有可能会遇到下面的这些困惑，于是就有了这样一篇文章，试图把Python中一些隐晦的东西趴出来，希望对你有一定的帮助。我们先来看两段代码：</p>
<p>片段一：</p>
<p>&gt;&gt;&gt;&nbsp;a&nbsp;=&nbsp;256&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;b&nbsp;=&nbsp;256&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;a&nbsp;==&nbsp;b&nbsp;&nbsp;True&nbsp;&nbsp;&gt;&gt;&gt;</p>
<p>片段二：</p>
<p>&gt;&gt;&gt;&nbsp;a&nbsp;=&nbsp;256&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;b&nbsp;=&nbsp;256&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;a&nbsp;is&nbsp;b&nbsp;&nbsp;True&nbsp;&nbsp;&gt;&gt;&gt;</p>
<p>在交互式命令行执行上面两段代码，代码片段一中的a==b返回True很好理解，因为两个对象的值都是256，对于片段二，a is b也返回True，这说明a和b是指向同一个对象的，可以检查一下他们的id值是否相等：</p>
<p>&gt;&gt;&gt;&nbsp;id(a)&nbsp;&nbsp;8213296&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;id(b)&nbsp;&nbsp;8213296&nbsp;&nbsp;&gt;&gt;&gt;</p>
<p>结果证明他俩的确是同一个对象，指向的是同一个内存地址。那是不是所有的整数对象只要两个对象的值(内容)相等，它们就是同一个实例对象呢?换句话说，对于整数对象只要==返回True，is操作也会返回True吗?带着这个问题来看下面这两段代码：</p>
<p>片段一：</p>
<p>&gt;&gt;&gt;&nbsp;a&nbsp;=&nbsp;257&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;b&nbsp;=&nbsp;257&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;a&nbsp;==&nbsp;b&nbsp;&nbsp;True&nbsp;&nbsp;&gt;&gt;&gt;</p>
<p>片段二：</p>
<p>&gt;&gt;&gt;&nbsp;a&nbsp;=&nbsp;257&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;b&nbsp;=&nbsp;257&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;a&nbsp;is&nbsp;b&nbsp;&nbsp;False&nbsp;&nbsp;&gt;&gt;yszx11.cn &gt;</p>
<p>对于257，a is b返回的竟然是False，结果可能在你的意料之中，也有可能出乎你的意料，但不管怎么，我们还是要刨根问底，找出问题的真相。</p>
<p>解惑一</p>
<p>出于对性能的考虑，Python内部做了很多的优化工作，对于整数对象，Python把一些频繁使用的整数对象缓存起来，保存到一个叫small_ints的链表中，在Python的整个生命周期内，任何需要引用这些整数对象的地方，都不再重新创建新的对象，而是直接引用缓存中的对象。Python把这些可能频繁使用的整数对象规定在范围[-5, 256]之间的小对象放在small_ints中，但凡是需要用些小整数时，就从这里面取，不再去临时创建新的对象。因为257不再小整数范围内，因此尽管a和b的值是一样，但是他们在Python内部却是以两个独立的对象存在的，各自为政，互不干涉。</p>
<p>弄明白第一个问题后，我们继续在Python交互式命令行中写一个函数，再来看下面这段代码：</p>
<p>片段一：</p>
<p>&gt;&gt;&gt;&nbsp;c&nbsp;=&nbsp;257&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;def&nbsp;foo():&nbsp;&nbsp;...&nbsp;a&nbsp;=&nbsp;257&nbsp;&nbsp;...&nbsp;b&nbsp;=&nbsp;257&nbsp;&nbsp;...&nbsp;print&nbsp;a&nbsp;is&nbsp;b&nbsp;&nbsp;...&nbsp;print&nbsp;a&nbsp;is&nbsp;c&nbsp;&nbsp;...&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;foo()&nbsp;&nbsp;True&nbsp;&nbsp;False</p>
<p>呃，什么情况，是的，你没看错，片段一中的这段代码 a、b 值都是257的情况下，出现了a is b返回True，而a is c 返回的False，a、b、c的值都为257，为什么会出现不同的结果呢?这对于刚刚好不容易建立起来的认知就被彻底否决了吗，那这段代码中究竟发生了什么?难道解惑一中的结论是错误的吗?</p>
<p>解惑二</p>
<p>A Python program is constructed from code blocks. A block is a piece of Python program text that is executed as a unit. The following are blocks: a module, a function body, and a class definition. Each command typed interactively is a block. A script file (a file given as standard input to the interpreter or specified as a command line argument to the interpreter) is a code block. A script command (a command specified on the interpreter command line with the &lsquo;-c&lsquo; option) is a code block. structure-of-a-program&nbsp;zhengshu5.com</p>
<p>为了弄清楚这个问题，我们有必要先理解程序代码块的概念。Python程序由代码块构成，代码块作为程序的一个最小基本单位来执行。一个模块文件、一个函数体、一个类、交互式命令中的单行代码都叫做一个代码块。在上面这段代码中，由两个代码块构成，c = 257作为一个代码块，函数foo作为另外一个代码块。Python内部为了将性能进一步的提高，凡是在一个代码块中创建的整数对象，如果存在一个值与其相同的对象于该代码块中了，那么就直接引用，否则创建一个新的对象出来。Python出于对性能的考虑，但凡是不可变对象，在同一个代码块中的对象，只有是值相同的对象，就不会重复创建，而是直接引用已经存在的对象。因此，不仅是整数对象，还有字符串对象也遵循同样的原则。所以 a is b就理所当然的返回True了，而c和a不在同一个代码块中，因此在Python内部创建了两个值都是257的对象。为了验证刚刚的结论，我们可以借用dis模块从字节码的角度来看看这段代码。</p>
<p>&gt;&gt;&gt;&nbsp;import&nbsp;dis&nbsp;&nbsp;&gt;&gt;&gt;&nbsp;dis.dis(foo)&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;LOAD_CONST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;(257)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3&nbsp;STORE_FAST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;(a)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6&nbsp;LOAD_CONST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;(257)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9&nbsp;STORE_FAST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;(b)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;12&nbsp;LOAD_FAST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;(a)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15&nbsp;LOAD_FAST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;(b)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;18&nbsp;COMPARE_OP&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8&nbsp;(is)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;21&nbsp;PRINT_ITEM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;22&nbsp;PRINT_NEWLINE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;23&nbsp;LOAD_FAST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;(a)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;26&nbsp;LOAD_GLOBAL&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;(c)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;29&nbsp;COMPARE_OP&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8&nbsp;(is)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;32&nbsp;PRINT_ITEM&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;33&nbsp;PRINT_NEWLINE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;34&nbsp;LOAD_CONST&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0&nbsp;(None)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37&nbsp;RETURN_VALUE</p>
<p>可以看出两个257都是从常量池的同一个位置co_consts[1]获取的。</p>
<p>总结</p>
<p>一番长篇大论之后，得出两点结论：1、小整数对象[-5,256]是全局解释器范围内被重复使用，永远不会被GC回收。2、同一个代码块中的不可变对象，只要值是相等的就不会重复创建新的对象。似乎这些知识点对日常的工作一点忙也帮不上，因为你根本不会用is来比较两个整数对象的值是否相等。那为什么还要拿出来讨论呢?嗯，程序员学知识，不应该浅尝辄止，要充分发挥死磕到底的精神。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pmlk9x.html">装饰者模式 Decoration</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m1kp8k.html">ASP&period;NET WebApi 文档Swagger中度优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xn508.html">ExtJs、Struts2、Hibernate3&period;2登录页面的简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvy2vyq.html">Testin云测试平台初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdepygx9.html">Android实现拖动进度条改变图片透明度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjwroq.html">解决Access连接 accdb 不可识别的数据库格式异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn6nd08.html">Java SE ---关系运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgpwxq.html">Cocos2d-x lua游戏开发之安装Lua到mac系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojg35lq.html">NancyFx 2&period;0的开源框架的使用-HosingOwin</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pgeyn8.html">Windows系统安装pip方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j1kd38.html">Android编写点击TextView拨打电话</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me0ke2q.html">django&period;core&period;exceptions&period;ImproperlyConfigured&colon; Error loading MySQLdb module&colon; No module named &amp;&num;39&semi;MySQLdb&amp;&num;39&semi;&period; Did you install mysqlclient or MySQL-python&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1j71pq.html">Java--druidAPI查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/960djd39.html">dos 打开计算机管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/960wv049.html">Python3 tkinter基础 Listbox for&plus;insert 将list中元素导入listbox中</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ygze9.html">Spring Boot项目使用maven-assembly-plugin根据不同环境打包成tar&period;gz或者zip</a>
		</li>
						<li><a href="https://www.batexi.com/a/93px0kz8.html">【tarjan&plus;SPFA】BZOJ1179-&lbrack;Apio2009&rsqb;Atm</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnvd44q.html">Python用&commat;property使类方法像属性一样访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk57n18.html">JZOJ&period;5307【NOIP2017模拟8&period;18】偷窃</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xw3ox9.html">selenium 上传文件方法补充&mdash;&mdash;SendKeys、win32gui</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdwl5w09.html">判断response&period;data是否为空</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjk41z9.html">React 开发注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll7nokq.html">HDU 3400</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2n0519.html">python第二周</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv05xx8.html">RabbitMQ  优先级队列-为队列赋权</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjk5pz9.html">基于 HTML5 Canvas 的 3D WebGL 机房创建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdx5e09.html">Linux lsof 命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2nkzz9.html">Mysql优化系列（1）--Innodb重要参数优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjkg079.html">HTML 5 拖放</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jw3mjq.html">Linux内核分析&mdash;&mdash;可执行程序的装载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
